$title Homework 10 Problem 1
$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;

set vars  /p1*p9/,
    years /1930*1962/,
    i/1*3/;

alias(years, y1, y2);
alias (vars, v);

scalar shift /1/,
       T,
       maxNonzero /3/,
       bigM /1500/,
       sigma /10/,
       totalErr;

$include iowheat.dat


parameter X(years, vars),
          y(years),
          norm(vars),
          TValues(i)/1 100, 2 200, 3 500/;

*fill X
loop((years, vars),
         X(years, vars) = wheatdata(years, vars)$(ord(vars) <= 8) +
                          shift$(ord(vars) = 9);
);
*scale X so that the norm of each column to 1
norm(vars) = sqrt(sum(y1, X(y1, vars)**2));
X(years, vars) = X(years, vars) / norm(vars);

*fill y
loop(years,
         y(years) = wheatdata(years, 'p9');
);

*check that norm of all columns is 1
*norm(vars) = sqrt(sum(y1, X(y1, vars)**2));
*display norm;

binary variable s(vars);

free variable b(vars),
              r(years),
              t1(vars),
              w(years),
              error(years),
              totalError;

equations
         EQ_error(years),
         EQ_leastSquares,
         EQ_norm1,
         EQ_l1,
         EQ_l11(years),
         EQ_l12(years),
         EQ_lasso1(vars),
         EQ_lasso2(vars),
         EQ_lasso3,
         EQ_vs1(vars),
         EQ_vs2(vars),
         EQ_vs3,
         EQ_huber1,
         EQ_huber2,
         EQ_huber3,
         EQ_huber4;

EQ_error(years)..
         error(years) =e= sum(v, X(years,v) * b(v)) - y(years);

EQ_leastSquares..
         totalError =e= sum(y1, error(y1)*error(y1));

EQ_l1..
         totalError =e= sum(y1, r(y1));

EQ_l11(years)..
         r(years) =g= error(years);

EQ_l12(years)..
         r(years) =g= -error(years);

EQ_lasso1(vars)..
         b(vars) =g= -t1(vars);

EQ_lasso2(vars)..
         b(vars) =l= t1(vars);

EQ_lasso3..
         sum(v, t1(v)) =l= T;

EQ_vs1(vars)..
         b(vars) =l= bigM * s(vars);

EQ_vs2(vars)..
         b(vars) =g= (-bigM) * s(vars);

EQ_vs3..
         sum(v, s(v)) =l= maxNonZero;

EQ_huber1..
         totalError =e= .5 * sum(y1, w(y1)*w(y1)) + sum(y1, y(y1)*w(y1));

EQ_huber2(vars)..
         sum(y1, X(y1, vars) * w(y1)) =e= 0;

EQ_huber3(years)..
         w(years) =g= -sigma;

EQ_huber4(years)..
         w(years) =l= sigma;

*open file
file wheat/wheat.txt/;
put wheat;

*models
model prob10a/EQ_error, EQ_leastSquares/;
model prob10b/EQ_error, EQ_l1, EQ_l11, EQ_l12/;
model prob10c/EQ_error, EQ_leastSquares, EQ_lasso1, EQ_lasso2, EQ_lasso3/;
model prob10d/EQ_vs1, EQ_vs2, EQ_vs3, EQ_error, EQ_l1, EQ_l11, EQ_l12/;
model prob10e/EQ_huber1, EQ_huber2, EQ_huber3, EQ_huber4/;

*set tolerances to 0
prob10a.optcr = 0;
prob10b.optcr = 0;
prob10c.optcr = 0;
prob10d.optcr = 0;
prob10e.optcr = 0;


put '******** PART A **********'/;
solve prob10a using nlp minimizing totalError;

put /'b values'/;
loop(vars,
         put @3, vars.tl, @15, b.l(vars):8:3/;
);

put /'|| Xb - y ||2^2: ', totalError.l/;

totalErr = sum(y1, abs(error.l(y1)));
put '|| Xb - y ||1: ', totalErr/;


put /'******** PART B **********'/;
solve prob10b using lp minimizing totalError;

put /'b values'/;
loop(vars,
         put @3, vars.tl, @15, b.l(vars):8:3/;
);

totalErr = sum(y1, error.l(y1)*error.l(y1));
put /'|| Xb - y ||2^2: ', totalErr/;
put '|| Xb - y ||1: ', totalError.l/;

put /'******** PART C **********'/;
loop(i,
*        set proper T value
         T = TValues(i);

         solve prob10c using nlp minimizing totalError;

*        fix least useful b values to 0
         loop(v,
               if(abs(b.l(v)) < 10**(-10),
                       b.l(v) = 0;
                       b.fx(v) = 0;
               );
         );

         solve prob10a using nlp minimizing totalError;
         put /'T = ' T/;
         put 'b values'/;
         loop(vars,
                 put @3, vars.tl, @15, b.l(vars):8:3/;
         );
         put /'|| Xb - y ||2^2: ', totalError.l/;

         totalErr = sum(y1, abs(error.l(y1)));
         put '|| Xb - y ||1: ', totalErr/;

*        unconstrain b for next time
         b.lo(vars) = -INF;
         b.up(vars) = INF;
);

totalError.l = 0;
b.l(vars) = 0;
r.l(years) = 0;

put /'******** PART D **********'/;
solve prob10d using mip minimizing totalError;

put /'b values'/;
loop(vars,
         put @3, vars.tl, @15, b.l(vars):8:3/;
);

totalErr = sum(y1, error.l(y1)*error.l(y1));
put /'|| Xb - y ||2^2: ', totalErr/;

totalErr = sum(y1, abs(error.l(y1)));
put '|| Xb - y ||1: ', totalErr/;

put /'******** PART E **********'/;
solve prob10e using nlp minimizing totalError;

put /'b values'/;
loop(vars,
         b.l(vars) = EQ_huber2.m(vars);
         put @3, vars.tl, @15, b.l(vars):8:3/;
);

error.l(years) = sum(v, X(years,v) * b.l(v)) - y(years);

totalErr = sum(y1, error.l(y1)*error.l(y1));
put /'|| Xb - y ||2^2: ', totalErr/;

totalErr = sum(y1, abs(error.l(y1)));
put '|| Xb - y ||1: ', totalErr/;
putclose wheat;