$title Homework 10 Problem 2
$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;

set j /1*11/

scalar sP pressure inside the tank(scalar edition),
       reconFactor factor in cost of recondensation /144/;

parameter values(j) /1 150, 2 160, 3 170, 4 180, 5 190,
                     6 200, 7 210, 8 220, 9 230, 10 240,
                     11 250/,
          cost(j);

free variables
         T temperature inside the tank,
         I thickness of instulation,
         P pressure inside the tank,
         CI cost insulation,
         CV cost of steel vessel,
         CR cost recondensation,
         totalCost total cost of tank;

equations
         EQ_P,
         EQ_CI,
         EQ_CV,
         EQ_CR,
         EQ_OBJ2VAR,
         EQ_OBJ6VAR;

EQ_P..
         P =e= exp(-3950/(T+460)+11.86);

EQ_CI..
         CI =e= 400*I**0.9;

EQ_CV..
         CV =e= 1000+22*(P-14.7)**1.2;

EQ_CR..
         CR =e= reconFactor*(80-T)/I;

EQ_OBJ2VAR..
         totalCost =e= 400 * I**0.9 +
                       1000 + 22*((exp(-3950/(T + 460) + 11.86) - 14.7)**1.2) +
                       reconFactor * (80 - T)/I;

EQ_OBJ6VAR..
         totalCost =e= CI + CV + CR;

*$ontext
T.l = 10;
I.l = 10;
P.l = 15;

model prob106/EQ_P, EQ_CI, EQ_CV, EQ_CR, EQ_OBJ6VAR/;
solve prob106 using nlp minimizing totalCost;

display T.l;
display I.l;
display P.l;
display CI.l;
display CV.l;
display CR.l;
display totalCost.l;

********************PART 2****************************

T.l = 10;
I.l = 10;
model prob102/EQ_OBJ2VAR/;
solve prob102 using nlp minimizing totalCost;

sP = exp(-3950/(T.l + 460) + 11.86);
display T.l;
display I.l;
display sP;
display totalCost.l;

*********************PART 3*****************************
loop(j,
         T.l = 10;
         I.l = 10;
         reconFactor = values(j);
         solve prob102 using nlp minimizing totalCost;
         cost(j) = totalCost.l;
);

display cost;

$ontext
a) I would prefer to use the 6 variable setup in the sense that it is easier to
   read.  It is easy to see the cost incurred by each aspect of the tank.
   However, the second formulation is probably easier for gams as it has less
   variables/equations to solve.

b) As shown in the listing file:
        T          =               5.864  temperature inside the tank
        I          =               5.954  thickness of instulation
        P          =              29.404  pressure inside the tank
        totalCost  =            5339.253  total cost of tank

c) After running 11 values it appears that the function increases linearly.
   This makes sense as the function that we are modifying is linear and we
   are modifying a constant factor.
$offtext