$title Homework 10 Problem 2
$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;

$offlisting
$Ontext

2. Liebman, Lasdon, Schrange and Waren describe the following problem in
 designing a steel tank to hold ammonia. The decision variables are
        T        the temperature inside the tank
        I        the thickness of the insulation
 The pressure inside the tank is a function of the temperature,
        P = exp(-3950/(T + 460) + 11.86)
 It is desired to minimize the cost of the tank, which has three components:
 insulation cost, which depends on the thickness; the cost of the steel vessel,
 which depends on the pressure; and the cost of a recondensation process for
 cooling the ammonia, which depends on both temperature and insulation thickness.
 A combination of engineering and economic considerations has yielded the
 following formulas:
        CI = 400 I0.9
        CV = 1000 + 22(P - 14.7)1.2
        CR = 144(80 - T)/I
 a. Formulate this problem in GAMS as a two-variable problem, and alternatively
   as a six-variable problem in which four of the variables can be substituted
   out. Which formulation would you prefer to work with?
 b. Using your preferred formulation, determine the parameters of the least-cost
   tank.
 c. Increasing the factor 144 in CR causes a proportional increase in the
   recondensation cost. Try several larger values, and describe in general terms
   how the total cost increases as a function of the increase in this factor.
   (Include your conclusions as comments in the code.)

$Offtext
$onlisting

scalar sP pressure inside the tank(scalar edition),
       reconFactor factor in cost of recondensation /144/;

free variables
         T temperature inside the tank,
         I thickness of instulation,
         P pressure inside the tank,
         CI cost insulation,
         CV cost of steel vessel,
         CR cost recondensation,
         totalCost total cost of tank;

equations
         EQ_P,
         EQ_CI,
         EQ_CV,
         EQ_CR,
         EQ_OBJ2VAR,
         EQ_OBJ6VAR;

EQ_P..
         P =e= exp(-3950/(T+460)+11.86);

EQ_CI..
         CI =e= 400*I**0.9;

EQ_CV..
         CV =e= 1000+22*(P-14.7)**1.2;

EQ_CR..
         CR =e= reconFactor*(80-T)/I;

EQ_OBJ2VAR..
         totalCost =e= 400 * I**0.9 +
                       1000 + 22*((exp(-3950/(T + 460) + 11.86) - 14.7)**1.2) +
                       reconFactor * (80 - T)/I;

EQ_OBJ6VAR..
         totalCost =e= CI + CV + CR;

*$ontext
T.l = 10;
I.l = 10;
P.l = 15;

model prob106/EQ_P, EQ_CI, EQ_CV, EQ_CR, EQ_OBJ6VAR/;
solve prob106 using nlp minimizing totalCost;

display T.l;
display I.l;
display P.l;
display CI.l;
display CV.l;
display CR.l;
display totalCost.l;
*$offtext

********************PART 2****************************
$ontext
T.l = 10;
I.l = 10;
model prob102/EQ_OBJ2VAR/;
solve prob102 using nlp minimizing totalCost;

sP = exp(-3950/(T.l + 460) + 11.86);
display T.l;
display I.l;
display sP;
display totalCost.l;
$offtext

$ontext
a) I would prefer to use the 6 variable setup in the sense that it is easier to
   read.  It is easy to see the cost incurred by each aspect of the tank.
   However, the second formulation is probably easier for gams as it has less
   variables/equations to solve.

b) As shown in the listing file:
        T          =               5.864  temperature inside the tank
        I          =               5.954  thickness of instulation
        P          =              29.404  pressure inside the tank
        totalCost  =            5339.253  total cost of tank

c)
$offtext