$title Homework 12 Problem 1
$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;

set S supply nodes / omaha, madison /;
set D demand nodes / portland, topeka, atlanta /;

scalar a      demand constant a /.5/,
       constD demand constant D /10/,
       b      supply constant b;

*set b
b = log(50)/log(10);

* cost of shipping from supply nodes to demand nodes
table cost(S,D)
        portland        topeka          atlanta
omaha         10             2               8
madison       11             3               7;

positive variables supply(S) supply at node S,
                   demand(D) demand at node D,
                   quantity(S,D) amount shipped from S to D (xij),
                   m_supply(S) marginal supply price at supply node S(psi),
                   m_demand(D) marginal demand price at demand node D(pdj);

equation supply_con(S), demand_con(D) supply and demand satisfaction,
         deliver_con(S,D) keep prices consistent,
         var_supply(S), var_demand(D) enforce variable demand & supply;

* flow out of S does not exceed supply
supply_con(S).. supply(S) =g= sum(D, quantity(S,D));

* flow into D meets demand
demand_con(D).. sum(S, quantity(S,D)) =g= demand(D);

* demand price at D at least equal to supply price at S  + transportation
deliver_con(S,D).. m_supply(S) + cost(S,D) =g= m_demand(D);

* supply in terms of price
var_supply(S)..
         supply(S) =e= m_supply(S)**b;

* demand in terms of price
var_demand(D)..
         demand(D) =e= constD / (m_demand(D))**a;

*avoid a divide by zero
m_demand.l(D) = 1;

* complementarity form
model transport / supply_con.m_supply, demand_con.m_demand, deliver_con.quantity,
                  var_demand.demand, var_supply.supply /;
solve transport using mcp;

*display constants
display constD;
display a;
display b;

*display variable levels
display supply.l;
display demand.l;
display quantity.l;
display m_supply.l;
display m_demand.l;