$title Homework 12 Problem 2
$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;

set S supply nodes / omaha, madison /;
set D demand nodes / portland, topeka, atlanta /;

scalar a      demand constant a /.5/,
       constD demand constant D /10/,
       b      supply constant b,
       constA tax constant A /.02/,
       constB tax constant B /.0016/;

*set b
b = log(50)/log(10);

* cost of shipping from supply nodes to demand nodes
table cost(S,D)
        portland        topeka          atlanta
omaha         10             2               8
madison       11             3               7;

positive variables supply(S) supply at node S,
                   demand(D) demand at node D,
                   madTax madisons progressive tax,
                   quantity(S,D) amount shipped from S to D (xij),
                   m_supply(S) marginal supply price at supply node S(psi),
                   m_demand(D) marginal demand price at demand node D(pdj);

equation supply_con(S), demand_con(D) supply and demand satisfaction,
         deliver_con(S,D) keep prices consistent,
         var_supply(S), var_demand(D) enforce variable demand & supply,
         tax enforce tax;

* flow out of S does not exceed supply
supply_con(S)..
         supply(S) =g= sum(D, quantity(S,D));

* flow into D meets demand
demand_con(D)..
         sum(S, quantity(S,D)) =g= demand(D);

* demand price at D at least equal to supply price at S  + transportation
deliver_con(S,D)..
         m_supply(S)*(1 + madTax$(sameas(S, 'madison'))) + cost(S,D) =g= m_demand(D);

* supply in terms of price
var_supply(S)..
         supply(S) =e= m_supply(S)**b;

* demand in terms of price
var_demand(D)..
         demand(D) =e= constD / (m_demand(D))**a;

* madisons tax in terms of quantity shipped
tax..
         madTax =e= constA + constB * sum(D, quantity('madison', D));

m_demand.l(D) = 1;
* complementarity form
model transport / supply_con.m_supply, demand_con.m_demand, deliver_con.quantity,
                  var_demand.demand, var_supply.supply, tax.madTax /;
solve transport using mcp;

*display constants
option constB:4;
display constD;
display a;
display b;
display constA;
display constB;

*display variable levels
display madTax.l;
display supply.l;
display demand.l;
display quantity.l;
display m_supply.l;
display m_demand.l;