$ondollar title Homework 2: Problem 1

$offsymxref offsymlist offuelxref offuellist offupper
option limrow = 0, limcol = 0;

set
    D/1*3/
    S/Cooley, Whitman/
    C/Minority, Non/;

free variable
totdist "total distance";

positive variables
stud(D, S, C) "number of students in each school by district";

*********DATA SECTION**********

scalar
         minEnroll  /300/
         maxEnroll  /450/
         totminstud /220/
         totstud    /795/;
parameter
		minPrct, maxPrct;

minPrct  = totminstud / totstud - .05;
maxPrct  = totminstud / totstud + .05;

table dist(D,S)
         Cooley    Whitman
1           1.2        2.3
2           2.2        0.9
3           1.8        0.8;

table pop(D,C)
         Minority        Non
1              50        175
2              50        250
3             120        150;

*******MODEL SECTION*********

equations
obj "min total distance",
min_enroll(S) "lower bound on enrollment",
max_enroll(S) "cap on enrollment",
no_hooky(D, C) "enforce attendance of all students",
min_percent(S) "lowerbound on minority percentage",
max_percent(S) "cap on minority percentage";

*totdist = SUM(students * dist to school)
obj..
totdist =e= sum((D, S, C), stud(D, S, C) * dist(D, S));

*ensure min number of students per school
min_enroll(S)..
sum((D,C), stud(D, S, C)) =g= minEnroll;

*dont exceed max enrollment
max_enroll(S)..
sum((D,C), stud(D, S, C)) =l= maxEnroll;

*enforce attendance of all students
no_hooky(D, C)..
sum(S, stud(D, S, C)) =e= pop(D,C);

*check percentages of minority students
min_percent(S)..
sum(D, stud(D, S, "Minority")) =g= minPrct * sum((D, C), stud(D, S, C));

max_percent(S)..
sum(D, stud(D, S, "Minority")) =l= maxPrct * sum((D, C), stud(D, S, C));

model problem1 /all/;

solve problem1 using lp minimizing totdist;
