$ondollar title Homework 2: Problem 2

$offsymxref offsymlist offuelxref offuellist offupper
option limrow = 0, limcol = 0;

set      I / 1MONTH, 2MONTH, 3MONTH, 4MONTH /
         months / jan, feb, mar, apr /;

free variable cashFinal;

positive variable
         invest(I, months) "investments by month";

*********DATA SECTION**********

scalar
         startcash / 400 /
         rate1     / 0.0015 /
         rate2     / 0.0025 /
         rate3     / 0.0030 /
         rate4     / 0.0035 /

parameters
         inFlow(months)  / jan -200, feb 300, mar -150, apr 50 /

*******MODEL SECTION*********

equations
EQcashBal "cash balance each month"
EQcashFinal "max cash in May";

* investments this month = inflow + matured investments
EQcashBal(months)..
sum(I, invest(I, months)) =e=
                 startcash$(sameas(months, 'jan')) + inFlow(months)
                 + (1 + rate1) * invest('1MONTH', months - 1)
                 + rate2 * invest('2MONTH', months - 1)
			  + (1 + rate2) * invest('2MONTH', months - 2)
                 + rate3 * invest('3MONTH', months - 1)
                 + rate3 * invest('3MONTH', months - 2)
                 + (1 + rate3) * invest('3MONTH', months - 3)
                 + rate4 * invest('4MONTH', months - 1)
                 + rate4 * invest('4MONTH', months - 2)
                 + rate4 * invest('4MONTH', months - 3)
                 + (1 + rate4) * invest('4MONTH', months - 4);

EQcashFinal..
cashFinal =e=    (1 + rate1) * invest('1MONTH', 'apr')
                 + rate2 * invest('2MONTH', 'apr')
			  + (1 + rate2) * invest('2MONTH', 'mar')
                 + rate3 * invest('3MONTH', 'apr')
                 + rate3 * invest('3MONTH', 'mar')
                 + (1 + rate3) * invest('3MONTH', 'feb')
                 + rate4 * invest('4MONTH', 'apr')
                 + rate4 * invest('4MONTH', 'mar')
                 + rate4 * invest('4MONTH', 'feb')
                 + (1 + rate4) * invest('4MONTH', 'jan');


model problem2 /all/;

solve problem2 using lp maximizing cashFinal;
