$offsymxref offsymlist offuelxref offuellist offupper
option limrow=0, limcol=0;

set activity/
         A "Find Site"
         B "Find Engineers"
         C "Hire Opening act"
         D "Set Radio and TV Ads"
         E "Set up ticket agents"
         F "Prepare Electronics"
         G "Print Advertising"
         H "Set up Transportation"
         I "Rehearsals"
         J "Last-Minute Details"
         /


;

free variable totalDuration
sumStart
;

alias (activity, ai, aj);

set pred(ai,aj)  "ai preceeds aj"/
         A.(B,C,E)
         B.F
         C.(D,G,H)
         (F,H).I
         I.J
/
;

parameter duration(activity) "in days"/
A 3
B 2
C 6
D 2
E 3
F 3
G 5
H 1
I 1.5
J 2
/
;

set roots(activity);
set leaves(activity);

positive variable
timeStart(activity)
completionTime(activity)
;

parameters
earliestStart(activity)
latestStart(activity)
earliestStartC(activity)
latestStartC(activity)
temp
;

equations
obj                              objective
EqTimeStart(ai,aj)               defines the start times for each activity
EqCompletionTime(activity)       defines the completion times for each activity
EqSumStart
*EqCompletionConst
*EqEarliestStart(activity)
*EqLatestStart(activity)
;



*obj..
*         shortestDuration =e= smax((ai,aj),completionTime(aj)$(pred(ai,aj))+
*                 completionTime(aj)$(roots(aj)))
*;

obj(activity)..
         totalDuration =g= CompletionTime(activity)
;

EqTimeStart(ai,aj)$(pred(ai,aj))..
         timeStart(aj) =g= (timeStart(ai)+duration(ai))
;




EqCompletionTime(activity)..
         completionTime(activity) =e= timeStart(activity)+duration(activity);

EqSumStart..
         sumStart =e= sum(activity,timeStart(activity));




model hw31a/obj,EqTimeStart,EqCompletionTime/;
solve hw31a using lp minimizing totalDuration;

totalDuration.fx=14;
*The timeStart variable in this model indicates the earliest possible start time for each activity
model hw31b1/EqTimeStart,EqCompletionTime,EqSumStart,obj/;
solve hw31b1 using lp minimizing sumStart;
display timeStart.l;
*display earliestStart.l;
loop(activity,earliestStart(activity)=timeStart.l(activity););


*The timeStart variable in this model indicates the latest possible start time for each activity
model hw31b2/EqTimeStart,EqCompletionTime,EqSumStart,obj/;
solve hw31b2 using lp maximizing sumStart;
display timeStart.l;
loop(activity,latestStart(activity)=timeStart.l(activity);
);

set critical(activity);

critical(activity)=yes$(earliestStart(activity)=latestStart(activity));

display critical, earliestStart, latestStart;

**************************************Part c***********************************************************************

*Code to determine the root and the leaf nodes
roots(ai) = yes;
loop(pred(ai,aj),
  roots(aj) = no;
);

leaves(ai) = yes;
loop(pred(ai,aj),
  leaves(ai) = no;
);


*Intializing the earliestStartC parameter
loop(activity,
         earliestStartC(activity)=0;
);

*Intializing the latestStartC parameter.
loop(activity,
         latestStartC(activity)=0;
);
**************This equation calculates the earliest possible start times***********************************
loop(aj,
         earliestStartC(aj)=smax(ai,(earliestStartC(ai)+duration(ai))$(pred(ai,aj)))+0
);

************To calculate the latest possible start times**************************************************

*This is the set preceeding the leaves
set secLast(ai);
*To calculate latest possible start times for leaves
loop(leaves,
         latestStartC(leaves)=totalDuration.l-duration(leaves);
*         seclastLeaves(ai)=yes$(pred(ai,leaves));
);

secLast(ai)=yes$(sum(leaves$(pred(ai,leaves)),1));



display secLast;

while(card(secLast)>0,
loop(secLast$(not roots(secLast)),
*      latestStartC(secLast)=smin(leaves$(pred(secLast,leaves)),(latestStartC(leaves)-duration(secLast)));
         temp=smin(leaves$(pred(secLast,leaves)),(latestStartC(leaves)-duration(secLast)));
        if((temp<latestStartC(secLast)and (latestStartC(secLast)<>0)),
                 latestStartC(secLast)=temp;
         );
         if(latestStartC(secLast)=0,
                 latestStartC(secLast)=temp;
         );
         display secLast;
    );
leaves(ai)=secLast(ai);
secLast(ai)=no;
display secLast;
secLast(ai)=yes$(sum(leaves$(pred(ai,leaves)),1));
display latestStartC;
);
*loop(ai$(not leaves(ai)),
*         latestStartC(ai)=smin(leaves,(latestStartC(leaves)-duration(ai))$(pred(ai,leaves)));
*);

display leaves;
display earliestStartC, latestStartC;
display secLast;