$ondollar title Homework 3: Problem 1

$offsymxref offsymlist offuelxref offuellist offupper
option limrow = 0, limcol = 0;

*********DATA SECTION**********

set activity /
        A "Find Site",
        B "Find Engineers",
        C "Hire Opening Act",
        D "Set Radio and TV Ads",
        E "Set Up Ticket Agents",
        F "Prepare Electronics",
        G "Print Advertising",
        H "Set up Transportation",
        I "Rehearsals",
        J "Last-Minute Details",
        K "Have the Concert"
/;

alias (activity,ai,aj);

set pred(ai,aj) "ai precedes aj" /
        A. (B,C,E)
        B . F
        C. (D,G,H)
        (F,H) . I
        I . J
        (A,B,C,D,E,F,G,H,I,J) . K
/;

parameter minval;

parameter duration(activity) "in days" /
        A       3
        B       2
        C       6
        D       2
        E       3
        F       3
        G       5
        H       1
        I       1.5
        J       2
        K       0
/;

free variable total_time,
              sum_starttimes;

positive variable starttime(activity);

equations
         EQ_time "define total time",
         EQ_pred(ai, aj) "enforce precession",
         EQ_sum_starttimes "the sum of all start times";

EQ_time..
         total_time =e= starttime('K');

EQ_pred(ai, aj)..
         starttime(aj) =g= (starttime(ai) + duration(ai))$pred(ai, aj);

EQ_sum_starttimes..
         sum_starttimes =e= sum(activity, starttime(activity));

*******MODEL SECTION*********

***PART A***
option starttime:1;
model problem1a /EQ_time, EQ_pred/;
problem1a.solprint = 0;

***CALCUALTE PROJECT DURATION
solve problem1a using lp minimizing total_time;
display "####### PART A OBJECTIVE (PROJECT DURATION) ################";
display total_time.l;

***PART B***
total_time.fx = total_time.l;
model problem1b /EQ_time, EQ_pred, EQ_sum_starttimes/;
problem1b.solprint = 0;

***CALCUALTE EARLIEST START TIMES
solve problem1b using lp minimizing sum_starttimes;
display "####### PART B EARLIEST START TIMES ################";
display starttime.l;

***CALCUALTE LATEST START TIMES
solve problem1b using lp maximizing sum_starttimes;
display "####### PART B LATEST START TIMES ################";
display starttime.l;

***PART C***

***CALCUALTE EARLIEST START TIMES
loop(aj,
         starttime.l(aj)=smax(ai,(starttime.l(ai) + duration(ai))$(pred(ai,aj)));
);

display "####### PART C EARLIEST START TIMES ################";
display starttime.l;

***CALCULATE LASTEST START TIMES
set leaves(activity),
    thisSet(activity),
    nextSet(activity);

leaves(activity) = yes;
loop(pred(ai, aj),
	leaves(ai) = no;
);

starttime.l(activity) = 0;
loop(leaves,
	starttime.l(leaves) = total_time.l - duration(leaves);
);

thisSet(activity) = no;
loop(leaves,
	thisSet(leaves) = yes;
);

nextSet(ai)=yes$(sum(thisSet$(pred(ai,thisSet)),1));

while(card(nextSet)>0,
	loop(nextSet,
	     minval = smin(thisSet$(pred(nextSet,thisSet)),(starttime.l(thisSet)-duration(nextSet)));
	     if((minval < starttime.l(nextSet) and (starttime.l(nextSet)<>0)),
	               starttime.l(nextSet) = minval;
	     );
	     if(starttime.l(nextSet) = 0,
	               starttime.l(nextSet) = minval;
	     );
	);
	
	thisSet(ai)=nextSet(ai);
	nextSet(ai)=no;

	nextSet(ai)=yes$(sum(thisSet$(pred(ai,thisSet)),1));
);


display "####### PART C LATEST START TIMES ################";
display starttime.l;
