$ondollar title Homework 3: Problem 2

$offsymxref offsymlist offuelxref offuellist offupper
option limrow = 0, limcol = 0;

*********DATA SECTION**********
set adtype / TV, MAG, RADIO/
    avltype(adtype) / TV, MAG /;

scalars
    budget "budget ($K)" / 1000 /
    timeAvail / 700 /;

parameters
    cost(adtype) "cost of 1 unit of ad ($K)" / TV 20, MAG 10, RADIO 2 /
    viewers(adtype) "vievers per unit ad(KK)" / TV 1.8, MAG 1, RADIO 0.25 /
    time(adtype) "person-days to produce one unit of ad" / TV 7, MAG 21, RADIO 1 /;

free variable
    total_viewers;

positive variables
    amount(adtype);

equations
    EQ_total_viewers "defines total viewers",
    EQ_budget "defines budget",
    EQ_time "time restraint";

EQ_total_viewers..
    total_viewers =e= sum(avltype, viewers(avltype) * amount(avltype));

EQ_budget..
    sum(avltype, cost(avltype) * amount(avltype)) =l= budget;

EQ_time..
    timeAvail =g= sum(avltype, time(avltype) * amount(avltype));



*******MODEL SECTION*********

***PART A***
model problem2a /EQ_total_viewers, EQ_budget/;
problem2a.solprint = 0;
*enforce min of 10 minutes tv
amount.lo('TV') = 10;

solve problem2a using lp maximizing total_viewers;
display "####### PART A ANSWERS ################";
display amount.l;

***PART B***

model problem2b /EQ_total_viewers, EQ_budget, EQ_time/;
problem2b.solprint = 0;
solve problem2b using lp maximizing total_viewers;
display "####### PART B ANSWERS ################";
display amount.l;

***PART C***
*add radio into the mix
avltype('RADIO') = yes;
solve problem2b using lp maximizing total_viewers;
display "####### PART C ANSWERS ################";
display amount.l;

***PART D***
* enforce min of 2 magazine ads
amount.lo('MAG') = 2;
*enforce max of 120 min of radio
amount.up('RADIO') = 120;
solve problem2b using lp maximizing total_viewers;
display "####### PART D ANSWERS ################";
display amount.l;
