$ondollar title Homework 4: Problem 2

$offsymxref offsymlist offuelxref offuellist offupper
option limrow = 0, limcol = 0;

************** DATA SECTION *************

set grades / defective, grade1, grade2, grade3, grade4 /
    methods / method1, method2 /
    i / 1*4/;

alias (grades, g);
alias (methods, m);

scalar cost_refire cost to refire a transistor / 25 /
       furnace_cap furnace capacity / 20000 /;

parameter cost(methods) / method1 50, method2 70 /
          demand(grades) / defective 0, grade1 3000, grade2 3000, grade3 2000, grade4 1000 /;

table yield(grades, methods)  percentage yields of melting methods
           method1     method2
defective    0.30        0.20
grade1       0.30        0.20
grade2       0.20        0.25
grade3       0.15        0.20
grade4       0.05        0.15
;

table refiringYield(g, grades)   yields from refiring
           defective    grade1    grade2    grade3    grade4
defective    0.30       0.25      0.15      0.20      0.10
grade1                  0.30      0.30      0.20      0.20
grade2                            0.40      0.30      0.30
grade3                                      0.50      0.50
;

positive variable amt_meth(methods)      amount of transitors made by each method,
                  amt_refire(grades, i)     amount of each grade to refire,
                  init_trans(grades)     amount trans in orginal batch,
                  re_trans(grades, i)       amount of trans from refiring,
                  final_trans(grades)    final amount of transitors;

free variable total_cost;

equations
         EQ_total_cost           define total cost,
         EQ_demand(grades)       define demand,
         EQ_production           limit on production by furnace capacity,
         EQ_final_trans(grades)  define final number of transitors,
         EQ_init_trans(grades)   define initial number of transitors,
         EQ_re_trans(grades, i)     define number of transitors refired,
         EQ_lim_refire(grades, i)   can only refire trans that are already made;

*total cost = sum over all methods(cost of method * amount made by that method)
*             + sum over all grades(cost of refiring * amount refired)
EQ_total_cost..
         total_cost =e= sum(methods, cost(methods) * amt_meth(methods)) +
                      sum((grades, i), cost_refire * amt_refire(grades, i));

*meet the demand for each grade of transitor
EQ_demand(grades)..
         final_trans(grades) =g= demand(grades);

*limit production
EQ_production..
         sum(methods, amt_meth(methods)) + sum((g, i), amt_refire(g, i))
                 =l= furnace_cap;

* final trans = initial trans - trans refired + trans from refiring
EQ_final_trans(grades)..
         final_trans(grades) =e=
                 init_trans(grades) - sum(i, amt_refire(grades, i))
                                    + sum(i, re_trans(grades, i));

*init trans = sum over all methods(yield method * amount made by that method)
EQ_init_trans(grades)..
         init_trans(grades) =e=
                 sum(methods, yield(grades, methods) * amt_meth(methods));
*refired trans = sum over all grades(yield of refiring that grade *
*                amount of that grade refired)
EQ_re_trans(grades, i)..
         re_trans(grades, i) =e=
                 sum(g, refiringYield(g, grades) * amt_refire(g, i));

*make sure to only refire trans that have already been made
EQ_lim_refire(grades, i)..
         amt_refire(grades, i) =l= re_trans(grades, i-1)
                                   + init_trans(grades)$(ord(i) = 1);


model problem1 /all/;
solve problem1 using lp minimizing total_cost;
display total_cost.l;
