$title Homework 6: Problem 1a

$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;
option mip = cplex;

set year /1*5/;
set plant /p1*p4/;
set datafields/
    generatingCapacity   generating capacity in million Kwh
    constructionCost     construction cost in million dollars
    operatingCost         annual operating cost in million dollars
/;

alias (year, y);
alias (plant, p);

parameter requiredCapacity(year) "in million Kwh"
          /1 80, 2 100, 3 120, 4 140, 5 160/;

table data(plant,datafields)
      generatingCapacity    constructionCost   operatingCost
p1        70                   20                1.5
p2        50                   16                0.8
p3        60                   18                1.3
p4        40                   14                0.6;

integer variable existing_plants(year, plant) the plants in existance at the beginning of each year,
                 plants_built(year, plant) new plants built at the beginning of each year;

free variable cost;

equations
    EQ_cost defines the total cost of production,
    EQ_power(year) ensure enough power is produced,
    EQ_nextyear(year, plant) terms of power plant state;

*total cost = construction costs + operating costs
EQ_cost..
         cost =e= sum((y, p), plants_built(y, p) *
                         (data(p, 'constructionCost') + data(p, 'operatingCost'))) +
                  sum((y, p), existing_plants(y, p) * data(p, 'operatingCost'));

*power produced each year > required power that year
EQ_power(year)..
         requiredCapacity(year) =l=
                  sum(p, (existing_plants(year, p) + plants_built(year, p))
                                                 * data(p, 'generatingCapacity'));

*existing plants this year = existing plants last year + plants built last year
EQ_nextyear(year, plant)..
         existing_plants(year, plant) =e= existing_plants(year-1, plant) +
                                          plants_built(year-1, plant);

model problem6 / all /;
problem6.optcr = 0;

solve problem6 using mip minimizing cost;

option plants_built:0:0:1;
option existing_plants:0:0:1;

display cost.l;
display plants_built.l;
display existing_plants.l;
