$title Homework 6: Problem 1b

$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;
option mip = cplex;

set year /1*5/;
set plant /p1*p4/;
set action /reopen,shutdown/;
set datafields/
    generatingCapacity   generating capacity in million Kwh
    constructionCost     construction cost in million dollars
    operatingCost         annual operating cost in million dollars
/;

alias (year, y);
alias (plant, p);

parameter requiredCapacity(year) "in million Kwh"
          /1 80, 2 100, 3 120, 4 140, 5 160/,
          existing_plants(plant) /p1 1, p2 1, p3 1, p4 1/;

table data(plant,datafields)
      generatingCapacity    constructionCost   operatingCost
p1        70                   20                1.5
p2        50                   16                0.8
p3        60                   18                1.3
p4        40                   14                0.6;

table costs(plant,action) in Million $
        reopen        shutdown
p1        1.9        1.7
p2        1.5        1.2
p3        1.6        1.3
p4        1.1        0.8;

binary variables running(year, plant) the plants in operation each year,
                 reopen(year, plant) the plants reopened in each year,
                 shutdown(year, plant) the plants shutdown each year

free variable cost;

equations
    EQ_cost defines the total cost of production,
    EQ_power(year) ensure enough power is produced,
    EQ_nextyear(year, plant) terms of power plant state;

*total cost = reopening costs + shutdown costs + operating costs
EQ_cost..
         cost =e= sum((y, p), reopen(y, p) * costs(p, 'reopen') +
                              shutdown(y, p) * costs(p, 'shutdown') +
                              running(y, p) * data(p, 'operatingCost'));

*power produced each year > required power that year
EQ_power(year)..
         sum(p, running(year, p) * data(p, 'generatingCapacity')) =g=
                                                         requiredCapacity(year);

*plants running this year = plants running last year + plants reopened - plants shutdown
EQ_nextyear(year, plant)..
         running(year, plant) =e=   existing_plants(plant)$(sameas(year, '1'))
                                  + running(year - 1, plant)
                                  + reopen(year, plant)
                                  - shutdown(year, plant);

model problem6 / all /;
problem6.optcr = 0;

solve problem6 using mip minimizing cost;

option running:0:0:1;
option reopen:0:0:1;
option shutdown:0:0:1;

display cost.l;
display reopen.l;
display shutdown.l;
display running.l;
