$title Homework 6: Problem 2

$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;
option mip = cplex;

set week /w1*w2/,
    day /day1*day7/,
    shift /1*6/,
    nurses /nurse1*nurse11/;

alias (shift, s, s1, s2);
alias (day, d);

set compatibleShifts(s1,s2) / (1,2,3).(4,5,6), 4.(1,2), 5.(2,3), 6.3/;

table         work(day,shift)
         1  2  3  4  5  6
day1     1  1  0  1  1  0
day2     1  0  1  1  1  1
day3     1  1  1  1  1  1
day4     1  1  1  1  0  1
day5     0  1  1  0  1  1
day6     0  0  0  1  1  1
day7     0  0  0  1  1  1
;


parameter
 minOnDuty(day) /day1 5, day2 8, day3 8, day4 8, day5 6, day6 5, day7 5/;

binary variable assignNurses(nurses,s1,s2);
positive variable totalOnDuty(week, day);
free variable overstaff;

equations
    EQ_totalOnDuty(week, day) define amount of nurses on duty,
    EQ_minOnDuty(week, day) enforce a minimum of nurses on duty,
    EQ_oneAssignment(nurses) nurses can only work one pair of compatiable shifts,
    EQ_minOverStaff objective: minimize number of unnessacary nurses on duty;

*define the total amount of nurses on duty each day, each week
EQ_totalOnDuty(week, day)..
    totalOnDuty(week, day) =e=
         sum((nurses, s1, s2)$(compatibleShifts(s1, s2)),
         (work(day, s1)$(ord(week)=1) + work(day, s2)$(ord(week)=2))
         * assignNurses(nurses, s1, s2));

*enforce minimum number of nurses required each day
EQ_minOnDuty(week, day)..
     totalOnDuty(week, day) =g= minOnDuty(day);

*only allow one compatable schedule assignment per nurse
EQ_oneAssignment(nurses)..
    sum((s1, s2)$(compatibleShifts(s1, s2)), assignNurses(nurses, s1, s2)) =e= 1;


*overtime = sum over both weeks of (total on duty - min needed)
EQ_minOverStaff..
     overstaff =e= sum((week, day), totalOnDuty(week, day) - minOnDuty(day));

model problem6 / all /;
problem6.optcr = 0;

solve problem6 using mip minimizing overstaff;

display minOnDuty;
display totalOnDuty.l;
display assignNurses.l;
