$title Homework 7: Problem 1

$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;
option mip = cplex;

set b box size /1*3/,
    i numbers to fill /1*9/,
    r rows /r1*r9/,
    c cols /c1*c9/;

alias (i, j);
alias (r, row);
alias (c, col);
alias (b, b1, b2);

table  problem(r,c)  given values
    c1   c2   c3   c4   c5   c6   c7   c8   c9
r1        6    7    8    5              3    4
r2             4
r3   3    1         2              9
r4        9              3         8
r5
r6             6         1              7
r7             3             7          4    8
r8                                 6
r9   4    7              8   5     3    2
;

free variable dummy a useless variable to use for solving;
binary variable arc(i, r, c);

equations
    EQ_given(i, row, col)        fill in given values,
    EQ_rows(i, row)              enforce one of each number in every row,
    EQ_cols(i, col)              enforce one of each number in every row,
    EQ_onePerSpace(row, col)     only allow one number per space,
    EQ_box(i, row, col)          enforce one of each number in each 3x3 box,
    EQ_solve                     used to solve;

* set given spaces
EQ_given(i, row, col)$(problem(row, col))..
         arc(i, row, col) =e= 1$(problem(row, col) = ord(i));

* one of each number in every row
EQ_rows(i, row)..
         sum(c, arc(i, row, c)) =e= 1;

* one of each number in every column
EQ_cols(i, col)..
         sum(r, arc(i, r, col)) =e= 1;

* only allow one number per space
EQ_onePerSpace(row, col)..
         sum(i, arc(i, row, col)) =e= 1;

* one of each number in each 3x3 box
EQ_box(i, row, col)$(mod(ord(row),3)=1 and mod(ord(col),3) = 1)..
         sum((b1, b2), arc(i, row + (ord(b1) - 1), col + (ord(b2) - 1))) =e= 1;

EQ_solve..
         dummy =e= 0;

model prob7 /all/;
prob7.optcr = 0;
solve prob7 using mip maximizing dummy;

parameter answer(r, c) used to store the final answer;

answer(r,c) = 0;

loop(i,
         answer(r, c)$(answer(r, c) = 0) = ord(i) * arc.l(i, r, c);
);

option answer:0;

display answer;

