$title Homework 9: Problem 2

$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;
option mip = cplex;

$ontext
2. (Rardin, p. 875) A machinist will remove excess metal from a rotary machine
 part by passing the cutting tool of a lathe along the 42 inches of part length.
 For a lathe turning at N revolutions per minute and advancing the tool at a
 feed rate of f inches per revolution, classical empirical relationships project
 the effective life of the cutting tool (in minutes) at

 tool life = [10.0/(N f^{0.60}) ]^{6.667}

 Each time a tool wears out, the operator must install a new one and spend 0.1
 hour realigning the machine. Engineers wish to choose the machining plan that
 minimizes total cost at $52/hour for machinist time and $87 for each new tool.
 Speed N must be in the interval [200,600] and feed rate f in the interval
 [.001,.005]. (Hint: Minimize the cost to manufacture one part.)
$offtext

scalar partLength  inches /42/
       installTime hours  /.1/
       minSpeed    revolutions per min /200/
       maxSpeed    revolutions per min /600/
       minFeedRate inches per rev /.001/
       maxFeedRate inches per rev /.005/
       laborCost  dollars(US) per hour /52/
       toolCost    dollars(US) /87/;

free variable costPerPart;
positive variables
         minPerPart time in minutes to complete each part,
         toolsPerPart number of tools needed for each part,
         N speed of lathe,
         F feed rate;

equations
         EQ_minPerPart time (min) to complete each part,
         EQ_toolsPerPart number of tools used for each part,
         EQ_costPerPart total cost per part;

* inch/min = (N * F)
* min/part = partLength / (N * F)
* min/tools = toolLife
* tools/part = (partLength / (N * F)) / toolLife

* time (min) to complete each part
EQ_minPerPart..
         minPerPart =e= partLength / (N * F);

* number of tools used for each part
EQ_toolsPerPart..
         toolsPerPart =e= minPerPart / ((10.0 / (N * F**(.60)))**(6.667));

* total cost = cost of labor + cost of parts
EQ_costPerPart..
         costPerPart =e= toolsPerPart * (toolCost + laborCost * installTime)
                                                 + minPerPart / 60 * laborCost;

N.lo = minSpeed;
N.up = maxSpeed;
F.lo = minFeedRate;
F.up = maxFeedRate;

model hw92 /all/;

solve hw92 using nlp minimizing costPerPart;

display N.l;
display F.l;
display costPerPart.l;
