$title Homework 9: Problem 3

$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;
option mip = cplex;

$ontext
 In an electrical network, the power loss incurred when a current of I amperes
 flows through a resistance of R ohms is (I^2 R) watts. In the figure below, 710
 amperes of current must be sent from node 1 to node 4. Resistances (in ohms)
 are indicated by the numbers next to each resistor. The current flowing through
 each node must satisfy conservation of flow. For example, total flow out of
 node 1 (flow through the 1-ohm resistor plus flow through the 4-ohm resistor)
 must equal the flow into node 1, which is 710 amperes. Remarkably, nature
 determines the current flow through each resistor by minimizing the total power
 loss in the network.

 Formulate a quadratic program to determine the current through each resistor,
 and solve it in GAMS.
$offtext

set nodes /1*4/;
alias (nodes, n, n1, n2);

set resistors(n1, n2) resistor from n1 to n2
    / 1 . (2,3)
      2 . (3,4)
      3 . 4
    /;

scalar startAmps /710/;

parameter R(n1, n2) resistance /1.2 1, 1.3 4, 2.3 6, 2.4 12, 3.4 3/;

free variable totalPowerLoss;

positive variable
         powerLoss(n1, n2) the amount of power loss over each arc,
         I flow in amps;

equations
         EQ_balance(nodes) flow in and out of node must be equal,
         EQ_powerLoss(n1, n2) measure power loss of each arc,
         EQ_totalPowerLoss total power loss;

* inflow = outflow
EQ_balance(nodes)..
         sum(n$resistors(n, nodes), I(n, nodes)) + startAmps$(ord(nodes)=1) =e=
                        sum(n$resistors(nodes, n), I(nodes, n)) + startAmps$(ord(nodes)=4);

* measure power lost on each resistor
EQ_powerLoss(n1, n2)$(resistors(n1, n2))..
         powerLoss(n1, n2) =e= R(n1, n2) * I(n1, n2)**2;

* measure total power lost
EQ_totalPowerLoss..
         totalPowerLoss =e= sum((n1, n2)$resistors(n1, n2), powerLoss(n1, n2));

model hw93 /all/;

solve hw93 using nlp minimizing totalPowerLoss;

display I.l;
display totalPowerLoss.l;



