$title Homework 10 Problem 1
$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;
option mip = cplex;

$offlisting
$Ontext

1. Take the first 8 columns of the "wheatdata" matrix (p1*p8) to be predictor
 variables and the last column (p9) to be a response variable. Add a ninth
 predictor variable: a constant shift. Letting X denote the predictor variable
 matrix and y denote the response variable vector, we seek regression
 coefficients b such that Xb approx= y.
   Scale the matrix of predictor variables X so that all its columns have a
 2-norm of 1. In a single GAMS file, calculate coefficients b according to
 different criteria, by solving the following problems. Be sure to use the most
 efficient solver possible in each case (that is, nlp or lp or mip, as
 appropriate).
 a. Least squares: minimize || Xb - y ||22
 b. l-1: minimize || Xb - y ||1 = sum_i | Xi b - yi |.
 c. LASSO: minimize || Xb - y ||2 subject to || b ||1 <= T, where T = 100, 200,
 500. For each value of T, identify the components of b that are (substantially)
 nonzero, then solve a least-squares problem without the constraint
 || b ||1 <= T in which just these components are allowed to be nonzero. (Hint:
 use a loop to avoid replicating solve statements.)
 d. Variable selection: minimize || Xb - y ||1, with at most 3 regression
 coefficients (components of b) taking on nonzero values.
 e. Solve the Huber regression problem with sigma=10, using the dual formulation
 described in class.

 Write out a file called wheat.txt (using "put") that tabulates the following
 for each variant of the regression problem above:
    * the optimal vales of the nine regression coefficients - the vector b;
    * the sum of squares || Xb - y ||22;
    * the l-1 norm || Xb - y ||1
 with an appropriate label for each entry.

$Offtext
$onlisting

set vars  /p1*p9/,
    years /1930*1962/;

scalar shift /70/;

$include iowheat.dat

parameter X(years, vars);
loop((years, vars),
         X(years, vars) = wheatdata(years, vars)$(ord(vars) < 9) +
                          shift$(ord(vars = 9));
);

parameter y(years);
loop(years,
         y(years) = wheatdata(years, 9);
};

free variable b;



