$title Homework 11: The Homework after Homework 10
$offuellist offuelxref offsymlist offsymxref
option limrow=0, limcol=0, solprint=off;

files points/points.dat/,
      path100/path100.dat/,
      path50/path50.dat/,
      path25/path25.dat/,
      path10/path10.dat/;

scalar maxDist/0.4/,
       curNode,
       nextNode;

set nodes/1*100/,
    arcs(nodes, nodes);

alias (nodes, n, n1, n2);

parameter x(nodes),
          y(nodes),
          distance(nodes, nodes),
          supply(nodes) /1 1, 2 -1/;

option seed = 902503;
x(nodes) = uniform(0,1);
y(nodes) = uniform(0,1);
x('1') = 0;
y('1') = 0;
x('2') = 1;
y('2') = 1;

*write out points to points.dat
put points;
loop(nodes,
         put x(nodes) y(nodes)/;
);
putclose points;

*calculate distances
distance(n1, n2) = sqrt((x(n1) - x(n2))*(x(n1) - x(n2)) +
                    (y(n1) - y(n2))*(y(n1) - y(n2)));

*only allow arcs under the tolerated distance
arcs(n1, n2) = yes$(distance(n1, n2) < maxDist);

free variable totalDistance;
positive variable flow(n1, n2);

equations
         EQ_balance(nodes),
         EQ_totalDistance;

EQ_balance(n)..
        sum(arcs(n, n2), flow(arcs)) - sum(arcs(n1, n), flow(arcs))
                                                                 =e= supply(n);

EQ_totalDistance..
        totalDistance =e= sum(arcs, flow(arcs) * distance(arcs));


model hw11/all/;
hw11.optcr = 0;

********** PART 1: 100 PTS ***************
solve hw11 using lp minimizing totalDistance;
display flow.l;
if(hw11.modelstat < 2,
*        write out path to file
         put path100;
         curNode = 1;
         while(curNode <> 2,
                 loop((n1, n2)$(ord(n1) = curNode and flow.l(n1, n2) = 1),
                                 put x(n1) y(n1)/;
                                 nextNode = ord(n2);
                 );
                 curNode = nextNode;
         );
         put x('2') y('2');
         putclose path100;
);

********** PART 2: 50 PTS ***************
flow.l(n1, n2) = 0;
loop((n1, n2)$(ord(n1)>50 or ord(n2)>50),
         arcs(n1, n2) = no;
);
solve hw11 using lp minimizing totalDistance;
if(hw11.modelstat < 2,
*        write out path to file
         put path50;
         curNode = 1;
         while(curNode <> 2,
                 loop((n1, n2)$(ord(n1) = curNode and flow.l(n1, n2) = 1),
                                 put x(n1) y(n1)/;
                                 nextNode = ord(n2);
                 );
                 curNode = nextNode;
         );
         put x('2') y('2');
         putclose path50;
);

********** PART 3: 25 PTS ***************
flow.l(n1, n2) = 0;
loop((n1, n2)$(ord(n1)>25 or ord(n2)>25),
         arcs(n1, n2) = no;
);
solve hw11 using lp minimizing totalDistance;
if(hw11.modelstat < 2,
*        write out path to file
         put path25;
         curNode = 1;
         while(curNode <> 2,
                 loop((n1, n2)$(ord(n1) = curNode and flow.l(n1, n2) = 1),
                                 put x(n1) y(n1)/;
                                 nextNode = ord(n2);
                 );
                 curNode = nextNode;
         );
         put x('2') y('2');
         putclose path25;
);

********** PART 4: 10 PTS ***************
flow.l(n1, n2) = 0;
loop((n1, n2)$(ord(n1)>10 or ord(n2)>10),
         arcs(n1, n2) = no;
);
solve hw11 using lp minimizing totalDistance;
if(hw11.modelstat < 2,
*        write out path to file
         put path10;
         curNode = 1;
         while(curNode <> 2,
                 loop((n1, n2)$(ord(n1) = curNode and flow.l(n1, n2) = 1),
                                 put x(n1) y(n1)/;
                                 nextNode = ord(n2);
                 );
                 curNode = nextNode;
         );
         put x('2') y('2');
         putclose path10;
);
