% HW11: Matlab plot code

% loads the data file plotXXX.dat into a matrix plotXXX.
load points.dat

%keep flags of which files exist
path = [1 1 1 1];
try, load path100.dat, catch fprintf 'File path100.dat does not exist'\n, path(1) = 0; end
try, load path50.dat,  catch fprintf 'File path50.dat does not exist'\n,  path(2) = 0; end
try, load path25.dat,  catch fprintf 'File path25.dat does not exist'\n,  path(3) = 0; end
try, load path10.dat,  catch fprintf 'File path10.dat does not exist'\n,  path(4) = 0; end

% take x to be first col of A, and let n be number of points.
x = points(:,1);
n = size(points,1);

figure(1);

if path(4) == 1 %all four paths exist
    h = plot(points(:,1), points(:,2),'x',path100(:,1),path100(:,2),'r-',...
        path50(:,1),path50(:,2),'g-',path25(:,1),path25(:,2),'c-',...
        path10(:,1),path10(:,2),'y-');
    legend(h,'pts','p100','p50','p25', 'p10',0);
elseif path(3) == 1 %three larger paths exist
    h = plot(points(:,1), points(:,2),'x',path100(:,1),path100(:,2),'r-',...
        path50(:,1),path50(:,2),'g-',path25(:,1),path25(:,2),'c-');
    legend(h,'pts','p100','p50','p25',0);
elseif path(2) == 1 %two larger paths exist
    h = plot(points(:,1), points(:,2),'x',path100(:,1),path100(:,2),'r-',...
        path50(:,1),path50(:,2),'g-');
    legend(h,'pts','p100','p50',0);
elseif path(1) == 1 %only path100 exists
    h = plot(points(:,1), points(:,2),'x',path100(:,1),path100(:,2),'r-');
    legend(h,'pts','p100',0);
else %no paths, print points
    h = plot(points(:,1), points(:,2),'x');
    legend(h,'pts',0);
end

%axis of evil
axis([0 1 0 1]);

% label the axes
xlabel('x'); ylabel('y');

% add a title
title('HW11: Plot of GAMS data in Matlab');


